<apex:page controller="PREPChangeIncludesController" id="pg" >
    <script type="text/javascript">
        function displaySearchRecords(){
            //var glAccountName = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.glAccountVal}' ).value;
            //var valuationClassName = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.valuationClassVal}' ).value;
            var groupCode = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.groupCodeVal}' ).value;
            var disciVal = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.disciplineVal}' ).value;
            var catVal = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.categoryVal}' ).value;
            var subCatVal = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.subCategoryVal}' ).value;
            var catManVal = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.categoryManagerVal}' ).value;
            var catSpecVal = document.getElementById( '{!$Component.pg.fm.pgBlockTop.pgBlockSectionTop.categorySpecialistVal}' ).value;
            
            if(( disciVal == null || disciVal == '' )
                && ( catVal == null || catVal == '' ) && ( subCatVal == null || subCatVal == '' )
                && ( catManVal == null || catManVal == '' ) && ( catSpecVal == null || catSpecVal == '' )
                && ( groupCode == null || groupCode == '' )){
                alert( 'Please select at least one filter' );
                return false;
            } else {
                displayRecords();
                return true;
            }
            
            displayRecords();
            return true;
        }
        
        function selectAllCheckboxes( allOrNoneCheckbox ){
            var container = allOrNoneCheckbox;
            while( container.tagName != "TABLE" ){
                container = container.parentNode;
            }
        
            // Switch all checkboxes
            var inputs = container.getElementsByTagName( "input" );
            var checked = allOrNoneCheckbox.checked;
            for( var i = 0; i < inputs.length; i++ ){ 
                var input = inputs.item( i );
                if( input.type == "checkbox" ){
                    if( input != allOrNoneCheckbox ){
                        input.checked = checked;
                    }
                }
            }
        }
        
        function checkRequiredValues( buttonText ){
            var requestVar = document.getElementById('{!$Component.pg.fm.pgBlock.pgBlockSection.pgSectionItem.reqText}').value;
            var taxSelectAll = document.getElementById('{!$Component.pg.fm.myPageBlock.taxTable.taxCheck}');
            var isSelected = false;
            
            while( taxSelectAll.tagName != "TABLE" ){
                taxSelectAll = taxSelectAll.parentNode;
            }
            
            // Switch all checkboxes
            var inputs = taxSelectAll.getElementsByTagName( "input" );
            for( var i = 0; i < inputs.length; i++ ){ 
                var input = inputs.item( i );
                if( input.type == "checkbox" && input.checked ){
                    isSelected = true;
                    break;
                }
            }
            
            if( requestVar == null || requestVar == '' ){
                alert( "Please enter Request Title." );
                return false;
            } else if( !isSelected ){
                alert( "Please select at least one record before submitting." );
                return false;
            } else {
                if( buttonText == 'Save' )
                    saveRecords();
                else
                    saveAndSubmitRecords();
                return true;
            }
        }
    </script>

    <apex:form id="fm" >
        <apex:outputpanel >
            <apex:actionstatus id="status">
                <apex:facet name="start">
                    <div class="waitingSearchDiv" id="el_loading" style="background-color: #fbfbfb;height: 100%;opacity:0.65;width:100%;"> 
                        <div class="waitingHolder" style="top: 74.2px; width: 91px;">
                            <img class="waitingImage" src="/img/loading.gif" title="Please Wait..." />
                            <span class="waitingDescription">Loading...</span>
                        </div>
                    </div>
                </apex:facet>
            </apex:actionstatus>
        </apex:outputpanel>
        
        <apex:actionFunction name="displayRecords" action="{!searchRecords}" status="status" />
        <apex:actionFunction name="saveRecords" action="{!saveChanges}" />
        <apex:actionFunction name="saveAndSubmitRecords" action="{!saveAndSubmitChanges}" />
        <!--<apex:actionFunction name="sortingCall" action="{!sortRecords}" status="status" >
            <apex:param name="sortValue123" value="" assignTo="{!sortOrder}"/>
        </apex:actionFunction>-->
                
        <apex:sectionHeader subtitle="PREP Taxonomy" title="Change Includes/Does Not Includes"/>
        
        <apex:pageBlock title="Search Records" id="pgBlockTop">
            <apex:pageBlockSection columns="2" id="pgBlockSectionTop" >
                <apex:inputField value="{!preInitiative.Discipline__c}" id="disciplineVal" />
                <apex:inputField value="{!preInitiative.Category__c}" id="categoryVal"/>
                <apex:inputField value="{!taxonomy.Sub_Category__c}" id="subCategoryVal" />
                <apex:inputField value="{!preInitiative.Category_Manager__c}" id="categoryManagerVal" />
                <apex:inputField value="{!preInitiative.Category_Specialist__c}" id="categorySpecialistVal" />
                <apex:inputField value="{!taxonomy.Name}" id="groupCodeVal"/>
                <!--<apex:inputField value="{!taxonomy.GL_Account__c}" id="glAccountVal"/>
                <apex:inputText id="valuationClassVal" value="{!valuationClassDesc}" label="Valuation Class"/>-->
            </apex:pageBlockSection>
            <apex:pageBlockButtons location="bottom" >                 
                <apex:commandButton value="Display Taxonomy / Initiatives" onClick="displaySearchRecords();" reRender="op1" status="status" />
           </apex:pageBlockButtons>
        </apex:pageBlock>
        
        <apex:outputPanel id="op1">
            <apex:pageBlock title="Search Results - Taxonomy" rendered="{!IF(taxonomyWrapperList.size = 0, false, true)}" id="myPageBlock">
                <apex:pageBlockTable value="{!taxonomyWrapperList}" var="tax" id="taxTable" >
                    <apex:column headerValue="">  
                        <apex:facet name="header">
                            <apex:inputCheckbox onclick="selectAllCheckboxes(this)" id="taxCheck" />
                        </apex:facet> 
                        <apex:inputCheckbox value="{!tax.selected}" />
                    </apex:column>
                    <apex:column headerValue="Owner" >
                        <apex:outputField value="{!tax.taxonomy.Owner.Name}" />
                    </apex:column>
                    <apex:column headerValue="Material/Service Group Code" >
                        <apex:outputLink value="/{!tax.taxonomy.Id}">{!tax.taxonomy.Name}</apex:outputLink>
                    </apex:column>
                    <apex:column headerValue="Material Service Group Name">
                        <apex:outputField value="{!tax.taxonomy.Material_Service_Group_Name__c}" />
                    </apex:column>
                    <apex:column headerValue="Includes" >
                        <apex:inputField value="{!tax.taxonomy.Includes__c}"/>
                    </apex:column>
                    <apex:column headerValue="Does Not Include">
                        <apex:inputField value="{!tax.taxonomy.Does_Not_Include__c}"/>
                    </apex:column>
                    <apex:column headerValue="Sub Category">
                        <apex:outputField value="{!tax.taxonomy.Sub_Category__c}" />
                    </apex:column>
                    <apex:column headerValue="Category" >
                        <apex:outputField value="{!tax.taxonomy.Category_Link__c}" />
                    </apex:column>
                    <apex:column headerValue="Discipline" >
                        <apex:outputField value="{!tax.taxonomy.Discipline_Link__c}" />
                    </apex:column>
                    <apex:column headerValue="Category Manager" >
                        <apex:outputField value="{!tax.taxonomy.Category_Manager__r.Name}" />
                    </apex:column>
                    <apex:column headerValue="Category Specialist" >
                        <apex:outputField value="{!tax.taxonomy.Category_Specialist__r.Name}" />
                    </apex:column>                                                                               
                </apex:pageBlockTable>
            </apex:pageBlock>
            
            <apex:pageBlock title="Reason for Change" rendered="{!IF(taxonomyWrapperList.size = 0, false, true)}" id="pgBlock" >
                <apex:pageBlockSection columns="1" id="pgBlockSection" >
                    <apex:pageBlockSectionItem id="pgSectionItem" >
                        Request Title:
                        <apex:outputPanel >
                            <apex:outputPanel style="width:3px;background-color:#c00;color:#c00;margin-right:2px;">|</apex:outputPanel>
                            <apex:inputText value="{!requestTitle}" id="reqText" /> 
                        </apex:outputPanel>
                    </apex:pageBlockSectionItem>
                </apex:pageBlockSection>
                <apex:pageBlockButtons location="bottom" >                 
                    <apex:commandButton value="Save" onclick="checkRequiredValues( 'Save' );" reRender="fm" />
                    <apex:commandButton value="Submit for Approval" onclick="checkRequiredValues( 'Submit' );" reRender="fm" />
               </apex:pageBlockButtons>
            </apex:pageBlock>
        </apex:outputPanel>
    </apex:form>
</apex:page>